For the complete documentation index, see llms.txt. This page is also available as Markdown.

Partially modify volumes

Update the properties of the specified storage volume within the data center.

patch
Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials.

Note:

  • Basic Authentication is supported only when 2-Factor Authentication is not configured.
  • Users with 2-Factor Authentication activated must generate new 2FA-secured tokens in the DCD using [Token Manager](https://docs.ionos.com/cloud/set-up-ionos-cloud/management/identity-access-management/token-manager). These tokens do not inherit the 2FA-secured property by default.
  • Token deletion is only possible using the Token Manager.
Separate your username and password with a colon, i.e., username:password and send it as 'Authorization' request header. More details: https://en.wikipedia.org/wiki/Basic_access_authentication
Path parameters
datacenterIdstringRequired

The unique ID of the data center.

volumeIdstringRequired

The unique ID of the volume.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
namestringOptional

The name of the resource.

Example: My resource
typestring · enumOptional

Hardware type of the volume. DAS (Direct Attached Storage) could be used only in a composite call with a Cube server. ESSENTIAL, BALANCED, and PERFORMANCE are the current performance classes (formerly HDD, SSD Standard, and SSD Premium respectively); the legacy names remain valid for existing volumes but are deprecated for new volumes.

Example: PERFORMANCEPossible values:
sizenumberRequired

The size of the volume in GB.

Example: 100
availabilityZonestring · enumOptional

The availability zone in which the volume should be provisioned. The storage volume will be provisioned on as few physical storage devices as possible, but this cannot be guaranteed upfront. This is uavailable for DAS (Direct Attached Storage), and subject to availability for SSD.

Example: AUTOPossible values:
imagestringOptional

Image or snapshot ID to be used as template for this volume. MSSQL Enterprise Images can be used only if the feature toggle for MSSQL Enterprise is enabled on the contract. If the referenced image supports Confidential Computing, additional rules apply: the volume can only be created inline as part of a server creation request (not via standalone volume creation, nor by attaching to an existing server), and exactly one volume on that server may use such an image. The resulting volume is permanently bound to the server as its boot device and cannot be detached or moved to another server.

Example: d6ad1576-fde9-4696-aa41-1ebd75bdaf49
imagePasswordstringOptional

Initial password to be set for installed OS. Works with public images only. Not modifiable, forbidden in update requests. Password rules allows all characters from a-z, A-Z, 0-9.

Example: mypass123
sshKeysstring[]Optional

Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation.

Example: ["ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/4JNoFQBsaGV974hDmloS5LOvSJjKpXs8Ed437ln712345","ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/asdfghjkjhyutry545tgvbn76e4rf43"]
busstring · enumOptional

The bus type for this volume; default is VIRTIO.

Example: VIRTIOPossible values:
licenceTypestringOptional

OS type for this volume.

Example: LINUX
applicationTypestringOptional

The type of application that is hosted on this resource. Only public images can have an Application type different than UNKNOWN.

Example: MSSQL-2019-Standard
cpuHotPlugbooleanOptional

Hot-plug capable CPU (no reboot required).

Example: true
ramHotPlugbooleanOptional

Hot-plug capable RAM (no reboot required).

Example: true
nicHotPlugbooleanOptional

Hot-plug capable NIC (no reboot required).

Example: true
nicHotUnplugbooleanOptional

Hot-unplug capable NIC (no reboot required).

Example: true
discVirtioHotPlugbooleanOptional

Hot-plug capable Virt-IO drive (no reboot required).

Example: true
discVirtioHotUnplugbooleanOptional

Hot-unplug capable Virt-IO drive (no reboot required). Not supported with Windows VMs.

Example: true
exposeSerialbooleanOptional

If set to true will expose the serial id of the disk attached to the server. If set to false will not expose the serial id. Some operating systems or software solutions require the serial id to be exposed to work properly. Exposing the serial can influence licensed software (e.g. Windows) behavior

Default: falseExample: true
requireLegacyBiosbooleanOptional

Indicates if the image requires the legacy BIOS for compatibility or specific needs.

Default: trueExample: true
deviceNumberinteger · int64Read-onlyOptional

The Logical Unit Number of the storage volume. Null for volumes, not mounted to a VM.

Example: 3
pciSlotinteger · int32Read-onlyOptional

The PCI slot number of the storage volume. Null for volumes, not mounted to a VM.

Example: 7
backupunitIdstring · uuidOptional

The ID of the backup unit that the user has access to. The property is immutable and is only allowed to be set on creation of a new a volume. It is mandatory to provide either 'public image' or 'imageAlias' in conjunction with this property.

Example: 25f67991-0f51-4efc-a8ad-ef1fb31a481c
userDatastringOptional

The cloud-init configuration for the volume as base64 encoded string. The property is immutable and is only allowed to be set on creation of a new a volume. It is mandatory to provide either 'public image' or 'imageAlias' that has cloud-init compatibility in conjunction with this property. This field is blocked for Confidential Computing VM storage.

bootServerstringRead-onlyOptional

The UUID of the attached server.

Example: 25f67991-0f51-4efc-a8ad-ef1fb31a481c
bootOrderstring · enum · nullableOptional

Determines whether the volume will be used as a boot volume. Set to NONE, the volume will not be used as boot volume. Set to PRIMARY, the volume will be used as boot volume and all other volumes must be set to NONE. Set to AUTO or null requires all volumes to be set to AUTO or null; this will use the legacy behavior, which is to use the volume as a boot volume only if there are no other volumes or cdrom devices. A volume with a Confidential Computing image may be created with bootOrder set to PRIMARY (or left unset / AUTO, in which case it is automatically treated as the boot device), but it must not be created with bootOrder set to NONE. Conversely, no other volume attached to the same server is allowed to be set to PRIMARY — only the confidential computing volume can be the boot device.

Default: AUTOExample: AUTOPossible values:
imageAliasstringOptional

Image alias of an image to be used as template for this volume. MSSQL Enterprise Images can be used only if the feature toggle for MSSQL Enterprise is enabled on the contract. If the referenced image supports Confidential Computing, additional rules apply: the volume can only be created inline as part of a server creation request (not via standalone volume creation, nor by attaching to an existing server), and exactly one volume on that server may use such an image. The resulting volume is permanently bound to the server as its boot device and cannot be detached or moved to another server.

Responses
202

Successful operation

application/json
patch/datacenters/{datacenterId}/volumes/{volumeId}
PATCH /cloudapi/v6/datacenters/{datacenterId}/volumes/{volumeId} HTTP/1.1
Host: api.ionos.com
Authorization: Basic username:password
Content-Type: application/json
Accept: */*
Content-Length: 1278

{
  "name": "My resource",
  "type": "PERFORMANCE",
  "size": 100,
  "availabilityZone": "AUTO",
  "image": "d6ad1576-fde9-4696-aa41-1ebd75bdaf49",
  "imagePassword": "mypass123",
  "sshKeys": [
    "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/4JNoFQBsaGV974hDmloS5LOvSJjKpXs8Ed437ln712345",
    "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/asdfghjkjhyutry545tgvbn76e4rf43"
  ],
  "bus": "VIRTIO",
  "licenceType": "LINUX",
  "applicationType": "MSSQL-2019-Standard",
  "cpuHotPlug": true,
  "ramHotPlug": true,
  "nicHotPlug": true,
  "nicHotUnplug": true,
  "discVirtioHotPlug": true,
  "discVirtioHotUnplug": true,
  "exposeSerial": true,
  "requireLegacyBios": true,
  "backupunitId": "25f67991-0f51-4efc-a8ad-ef1fb31a481c",
  "userData": "text",
  "bootOrder": "AUTO",
  "imageAlias": "text"
}
{
  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
  "type": "volume",
  "href": "<RESOURCE-URI>",
  "metadata": {
    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
    "createdDate": "2015-12-04T14:34:09.809Z",
    "createdBy": "user@example.com",
    "createdByUserId": "user@example.com",
    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
    "lastModifiedBy": "user@example.com",
    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
    "state": "AVAILABLE"
  },
  "properties": {
    "name": "My resource",
    "type": "PERFORMANCE",
    "size": 100,
    "availabilityZone": "AUTO",
    "image": "d6ad1576-fde9-4696-aa41-1ebd75bdaf49",
    "imagePassword": "mypass123",
    "sshKeys": [
      "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/4JNoFQBsaGV974hDmloS5LOvSJjKpXs8Ed437ln712345",
      "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/asdfghjkjhyutry545tgvbn76e4rf43"
    ],
    "bus": "VIRTIO",
    "licenceType": "LINUX",
    "applicationType": "MSSQL-2019-Standard",
    "cpuHotPlug": true,
    "ramHotPlug": true,
    "nicHotPlug": true,
    "nicHotUnplug": true,
    "discVirtioHotPlug": true,
    "discVirtioHotUnplug": true,
    "exposeSerial": true,
    "requireLegacyBios": true,
    "deviceNumber": 3,
    "pciSlot": 7,
    "backupunitId": "25f67991-0f51-4efc-a8ad-ef1fb31a481c",
    "userData": "text",
    "bootServer": "25f67991-0f51-4efc-a8ad-ef1fb31a481c",
    "bootOrder": "AUTO"
  }
}

Last updated

Was this helpful?